#!/usr/bin/env python

# $Id$

import sys
if not hasattr(sys, 'version_info') or sys.version_info < (2, 4):
    raise SystemExit, 'Muttils requires Python 2.4 or later'

from distutils.core import setup
import os.path, subprocess, time

version = None

if os.path.isdir('.hg'):
    v, e = subprocess.Popen(['hg', 'id', '-i', '-t'],
                            stdout=subprocess.PIPE,
                            stderr=subprocess.PIPE).communicate()
    if e:
        sys.stderr.write('warning: could not establish muttils '
                         'version:\n%s\n' % e)
    else:
        v = v.split()
        while len(v) > 1 and v[-1][0].isalpha(): # no numbered tags
            v.pop()
        version = v[-1] # latest tag or revision number
        if version.endswith('+'):
            version += time.strftime('%Y%m%d')
elif os.path.isfile('.hg_archival.txt'):
    fp = open('.hg_archival.txt')
    for line in fp:
        if line.startswith('node:'):
            version = line.split(':', 1)[1].strip()[:12]
            break
    fp.close()

if version:
    fp = open('muttils/__version__.py', 'w')
    fp.write('# this file is autogenerated by setup.py\n')
    fp.write('version = "%s"\n' % version)
    fp.close()

try:
    from muttils import __version__
    version = __version__.version
except ImportError:
    version = 'unknown'

setup(name='muttils',
      version=version,
      description='Python utilities for console mail clients (eg. mutt)',
      author='Christian Ebert',
      author_email='blacktrash@gmx.net',
      url='http://www.blacktrash.org/hg/muttils/',
      packages=['muttils'],
      scripts=['sigpager', 'urlbatcher', 'urlpager',
               'pybrowser', 'wrap', 'viewhtmlmsg'])
